FROM maven:3.8-openjdk-11 as MAVEN_BUILD
COPY ConfigServer/pom.xml /tmp/
COPY ConfigServer/src /tmp/src/
WORKDIR /tmp/
#VOLUME $HOME/.m2 /root/.m2
RUN mvn clean package


FROM adoptopenjdk/openjdk11:jdk-11.0.11_9-alpine as default
RUN addgroup --gid 1000 -S configserver
RUN adduser -S configserver -u 1000 -G configserver
USER configserver
COPY --from=MAVEN_BUILD /tmp/target/ConfigServer-0.0.1-SNAPSHOT.jar /usr/src/myapp/ConfigServer.jar
ENTRYPOINT ["java","-jar","/usr/src/myapp/ConfigServer.jar"]
EXPOSE 8888



FROM adoptopenjdk/openjdk11:jdk-11.0.11_9-alpine as staging
# Store IntermediateCA in JAVA_HOME TrustStore
ADD CONFIG/Vault/TLS_Certs/IntermediateCA/intermediateCA.pem $JAVA_HOME/lib/security/intermediateCA.pem
RUN keytool -importcert -alias intermediateCA -noprompt -file $JAVA_HOME/lib/security/intermediateCA.pem -cacerts -storepass changeit
ENV CONFIGSERVER_KEYSTORE=file:$JAVA_HOME/lib/security/config.p12 CONFIGSERVER_ENCRYPT_KEYSTORE=file:$JAVA_HOME/lib/security/configencrypt.p12

RUN addgroup --gid 1000 -S configserver
RUN adduser -S configserver -u 1000 -G configserver
USER configserver
COPY --from=MAVEN_BUILD /tmp/target/ConfigServer-0.0.1-SNAPSHOT.jar /usr/src/myapp/ConfigServer.jar
ENTRYPOINT ["java","-jar","/usr/src/myapp/ConfigServer.jar"]
EXPOSE 8888


FROM adoptopenjdk/openjdk11:jdk-11.0.11_9-alpine as production
# Store IntermediateCA in JAVA_HOME TrustStore
ADD CONFIG/Vault/TLS_Certs/IntermediateCA/intermediateCA.pem $JAVA_HOME/lib/security/intermediateCA.pem
RUN keytool -importcert -alias intermediateCA -noprompt -file $JAVA_HOME/lib/security/intermediateCA.pem -cacerts -storepass changeit
ENV CONFIGSERVER_KEYSTORE=file:$JAVA_HOME/lib/security/config.p12 CONFIGSERVER_ENCRYPT_KEYSTORE=file:$JAVA_HOME/lib/security/configencrypt.p12

RUN addgroup --gid 1000 -S configserver
RUN adduser -S configserver -u 1000 -G configserver
USER configserver
COPY --from=MAVEN_BUILD /tmp/target/ConfigServer-0.0.1-SNAPSHOT.jar /usr/src/myapp/ConfigServer.jar
ENTRYPOINT ["java","-jar","/usr/src/myapp/ConfigServer.jar"]
EXPOSE 8888